#ifndef __byteswap__
#define __byteswap__

#include "stock.h"

#ifdef  __cplusplus
extern "C" {
#endif

/* New comprehensive routines */

/* Three byte routines */
extern int vt2hi ( void *vfrom, int *to, int n );
extern int mt2hi ( void *vfrom, int *to, int n );
extern int hi2mt ( int *from, void *vto, int n );
extern int hi2vt ( int *from, void *vto, int n );
extern int vt2hf ( void *vfrom, float *to, int n );
extern int mt2hf ( void *vfrom, float *to, int n );

#define at2hi vt2hi
#define hi2at hi2vt

extern int ab2hb ( void *vfrom, char *to, int n );
extern int hb2ab ( char *from, void *vto, int n );
extern int uab2hb ( void *vfrom, unsigned char *to, int n );
extern int uhb2ab ( unsigned char *from, void *vto, int n );
extern int ab2hs ( void *vfrom, short *to, int n );
extern int hs2ab ( short *from, void *vto, int n );
extern int uab2hs ( void *vfrom, unsigned short *to, int n );
extern int uhs2ab ( unsigned short *from, void *vto, int n );
extern int ab2hi ( void *vfrom, int *to, int n );
extern int hi2ab ( int *from, void *vto, int n );
extern int uab2hi ( void *vfrom, unsigned int *to, int n );
extern int uhi2ab ( unsigned int *from, void *vto, int n );
extern int ab2hl ( void *vfrom, int64_t *to, int n );
extern int hl2ab ( int64_t *from, void *vto, int n );
extern int uab2hl ( void *vfrom, uint64_t *to, int n );
extern int uhl2ab ( uint64_t *from, void *vto, int n );
extern int ab2hf ( void *vfrom, float *to, int n );
extern int hf2ab ( float *from, void *vto, int n );
extern int uab2hf ( void *vfrom, float *to, int n );
extern int uhf2ab ( float *from, void *vto, int n );
extern int ab2hd ( void *vfrom, double *to, int n );
extern int hd2ab ( double *from, void *vto, int n );
extern int uab2hd ( void *vfrom, double *to, int n );
extern int uhd2ab ( double *from, void *vto, int n );
extern int as2hs ( void *vfrom, short *to, int n );
extern int hs2as ( short *from, void *vto, int n );
extern int uas2hs ( void *vfrom, unsigned short *to, int n );
extern int uhs2as ( unsigned short *from, void *vto, int n );
extern int as2hi ( void *vfrom, int *to, int n );
extern int hi2as ( int *from, void *vto, int n );
extern int uas2hi ( void *vfrom, unsigned int *to, int n );
extern int uhi2as ( unsigned int *from, void *vto, int n );
extern int as2hl ( void *vfrom, int64_t *to, int n );
extern int hl2as ( int64_t *from, void *vto, int n );
extern int uas2hl ( void *vfrom, uint64_t *to, int n );
extern int uhl2as ( uint64_t *from, void *vto, int n );
extern int as2hf ( void *vfrom, float *to, int n );
extern int hf2as ( float *from, void *vto, int n );
extern int uas2hf ( void *vfrom, float *to, int n );
extern int uhf2as ( float *from, void *vto, int n );
extern int as2hd ( void *vfrom, double *to, int n );
extern int hd2as ( double *from, void *vto, int n );
extern int uas2hd ( void *vfrom, double *to, int n );
extern int uhd2as ( double *from, void *vto, int n );
extern int ai2hi ( void *vfrom, int *to, int n );
extern int hi2ai ( int *from, void *vto, int n );
extern int uai2hi ( void *vfrom, unsigned int *to, int n );
extern int uhi2ai ( unsigned int *from, void *vto, int n );
extern int ai2hl ( void *vfrom, int64_t *to, int n );
extern int hl2ai ( int64_t *from, void *vto, int n );
extern int uai2hl ( void *vfrom, uint64_t *to, int n );
extern int uhl2ai ( uint64_t *from, void *vto, int n );
extern int ai2hf ( void *vfrom, float *to, int n );
extern int hf2ai ( float *from, void *vto, int n );
extern int uai2hf ( void *vfrom, float *to, int n );
extern int uhf2ai ( float *from, void *vto, int n );
extern int ai2hd ( void *vfrom, double *to, int n );
extern int hd2ai ( double *from, void *vto, int n );
extern int uai2hd ( void *vfrom, double *to, int n );
extern int uhd2ai ( double *from, void *vto, int n );
extern int al2hl ( void *vfrom, int64_t *to, int n );
extern int hl2al ( int64_t *from, void *vto, int n );
extern int ual2hl ( void *vfrom, uint64_t *to, int n );
extern int uhl2al ( uint64_t *from, void *vto, int n );
extern int al2hd ( void *vfrom, double *to, int n );
extern int hd2al ( double *from, void *vto, int n );
extern int ual2hd ( void *vfrom, double *to, int n );
extern int uhd2al ( double *from, void *vto, int n );
extern int af2hi ( void *vfrom, int *to, int n );
extern int hi2af ( int *from, void *vto, int n );
extern int uaf2hi ( void *vfrom, unsigned int *to, int n );
extern int uhi2af ( unsigned int *from, void *vto, int n );
extern int af2hl ( void *vfrom, int64_t *to, int n );
extern int hl2af ( int64_t *from, void *vto, int n );
extern int uaf2hl ( void *vfrom, uint64_t *to, int n );
extern int uhl2af ( uint64_t *from, void *vto, int n );
extern int af2hf ( void *vfrom, float *to, int n );
extern int hf2af ( float *from, void *vto, int n );
extern int af2hd ( void *vfrom, double *to, int n );
extern int hd2af ( double *from, void *vto, int n );
extern int ad2hl ( void *vfrom, int64_t *to, int n );
extern int hl2ad ( int64_t *from, void *vto, int n );
extern int uad2hl ( void *vfrom, uint64_t *to, int n );
extern int uhl2ad ( uint64_t *from, void *vto, int n );
extern int ad2hd ( void *vfrom, double *to, int n );
extern int hd2ad ( double *from, void *vto, int n );
extern int mb2hb ( void *vfrom, char *to, int n );
extern int hb2mb ( char *from, void *vto, int n );
extern int umb2hb ( void *vfrom, unsigned char *to, int n );
extern int uhb2mb ( unsigned char *from, void *vto, int n );
extern int mb2hs ( void *vfrom, short *to, int n );
extern int hs2mb ( short *from, void *vto, int n );
extern int umb2hs ( void *vfrom, unsigned short *to, int n );
extern int uhs2mb ( unsigned short *from, void *vto, int n );
extern int mb2hi ( void *vfrom, int *to, int n );
extern int hi2mb ( int *from, void *vto, int n );
extern int umb2hi ( void *vfrom, unsigned int *to, int n );
extern int uhi2mb ( unsigned int *from, void *vto, int n );
extern int mb2hl ( void *vfrom, int64_t *to, int n );
extern int hl2mb ( int64_t *from, void *vto, int n );
extern int umb2hl ( void *vfrom, uint64_t *to, int n );
extern int uhl2mb ( uint64_t *from, void *vto, int n );
extern int mb2hf ( void *vfrom, float *to, int n );
extern int hf2mb ( float *from, void *vto, int n );
extern int umb2hf ( void *vfrom, float *to, int n );
extern int uhf2mb ( float *from, void *vto, int n );
extern int mb2hd ( void *vfrom, double *to, int n );
extern int hd2mb ( double *from, void *vto, int n );
extern int umb2hd ( void *vfrom, double *to, int n );
extern int uhd2mb ( double *from, void *vto, int n );
extern int ms2hs ( void *vfrom, short *to, int n );
extern int hs2ms ( short *from, void *vto, int n );
extern int ums2hs ( void *vfrom, unsigned short *to, int n );
extern int uhs2ms ( unsigned short *from, void *vto, int n );
extern int ms2hi ( void *vfrom, int *to, int n );
extern int hi2ms ( int *from, void *vto, int n );
extern int ums2hi ( void *vfrom, unsigned int *to, int n );
extern int uhi2ms ( unsigned int *from, void *vto, int n );
extern int ms2hl ( void *vfrom, int64_t *to, int n );
extern int hl2ms ( int64_t *from, void *vto, int n );
extern int ums2hl ( void *vfrom, uint64_t *to, int n );
extern int uhl2ms ( uint64_t *from, void *vto, int n );
extern int ms2hf ( void *vfrom, float *to, int n );
extern int hf2ms ( float *from, void *vto, int n );
extern int ums2hf ( void *vfrom, float *to, int n );
extern int uhf2ms ( float *from, void *vto, int n );
extern int ms2hd ( void *vfrom, double *to, int n );
extern int hd2ms ( double *from, void *vto, int n );
extern int ums2hd ( void *vfrom, double *to, int n );
extern int uhd2ms ( double *from, void *vto, int n );
extern int mi2hi ( void *vfrom, int *to, int n );
extern int hi2mi ( int *from, void *vto, int n );
extern int umi2hi ( void *vfrom, unsigned int *to, int n );
extern int uhi2mi ( unsigned int *from, void *vto, int n );
extern int mi2hl ( void *vfrom, int64_t *to, int n );
extern int hl2mi ( int64_t *from, void *vto, int n );
extern int umi2hl ( void *vfrom, uint64_t *to, int n );
extern int uhl2mi ( uint64_t *from, void *vto, int n );
extern int mi2hf ( void *vfrom, float *to, int n );
extern int hf2mi ( float *from, void *vto, int n );
extern int umi2hf ( void *vfrom, float *to, int n );
extern int uhf2mi ( float *from, void *vto, int n );
extern int mi2hd ( void *vfrom, double *to, int n );
extern int hd2mi ( double *from, void *vto, int n );
extern int umi2hd ( void *vfrom, double *to, int n );
extern int uhd2mi ( double *from, void *vto, int n );
extern int ml2hl ( void *vfrom, int64_t *to, int n );
extern int hl2ml ( int64_t *from, void *vto, int n );
extern int uml2hl ( void *vfrom, uint64_t *to, int n );
extern int uhl2ml ( uint64_t *from, void *vto, int n );
extern int ml2hd ( void *vfrom, double *to, int n );
extern int hd2ml ( double *from, void *vto, int n );
extern int uml2hd ( void *vfrom, double *to, int n );
extern int uhd2ml ( double *from, void *vto, int n );
extern int mf2hi ( void *vfrom, int *to, int n );
extern int hi2mf ( int *from, void *vto, int n );
extern int umf2hi ( void *vfrom, unsigned int *to, int n );
extern int uhi2mf ( unsigned int *from, void *vto, int n );
extern int mf2hl ( void *vfrom, int64_t *to, int n );
extern int hl2mf ( int64_t *from, void *vto, int n );
extern int umf2hl ( void *vfrom, uint64_t *to, int n );
extern int uhl2mf ( uint64_t *from, void *vto, int n );
extern int mf2hf ( void *vfrom, float *to, int n );
extern int hf2mf ( float *from, void *vto, int n );
extern int mf2hd ( void *vfrom, double *to, int n );
extern int hd2mf ( double *from, void *vto, int n );
extern int md2hl ( void *vfrom, int64_t *to, int n );
extern int hl2md ( int64_t *from, void *vto, int n );
extern int umd2hl ( void *vfrom, uint64_t *to, int n );
extern int uhl2md ( uint64_t *from, void *vto, int n );
extern int md2hd ( void *vfrom, double *to, int n );
extern int hd2md ( double *from, void *vto, int n );
extern int vb2hb ( void *vfrom, char *to, int n );
extern int hb2vb ( char *from, void *vto, int n );
extern int uvb2hb ( void *vfrom, unsigned char *to, int n );
extern int uhb2vb ( unsigned char *from, void *vto, int n );
extern int vb2hs ( void *vfrom, short *to, int n );
extern int hs2vb ( short *from, void *vto, int n );
extern int uvb2hs ( void *vfrom, unsigned short *to, int n );
extern int uhs2vb ( unsigned short *from, void *vto, int n );
extern int vb2hi ( void *vfrom, int *to, int n );
extern int hi2vb ( int *from, void *vto, int n );
extern int uvb2hi ( void *vfrom, unsigned int *to, int n );
extern int uhi2vb ( unsigned int *from, void *vto, int n );
extern int vb2hl ( void *vfrom, int64_t *to, int n );
extern int hl2vb ( int64_t *from, void *vto, int n );
extern int uvb2hl ( void *vfrom, uint64_t *to, int n );
extern int uhl2vb ( uint64_t *from, void *vto, int n );
extern int vb2hf ( void *vfrom, float *to, int n );
extern int hf2vb ( float *from, void *vto, int n );
extern int uvb2hf ( void *vfrom, float *to, int n );
extern int uhf2vb ( float *from, void *vto, int n );
extern int vb2hd ( void *vfrom, double *to, int n );
extern int hd2vb ( double *from, void *vto, int n );
extern int uvb2hd ( void *vfrom, double *to, int n );
extern int uhd2vb ( double *from, void *vto, int n );
extern int vs2hs ( void *vfrom, short *to, int n );
extern int hs2vs ( short *from, void *vto, int n );
extern int uvs2hs ( void *vfrom, unsigned short *to, int n );
extern int uhs2vs ( unsigned short *from, void *vto, int n );
extern int vs2hi ( void *vfrom, int *to, int n );
extern int hi2vs ( int *from, void *vto, int n );
extern int uvs2hi ( void *vfrom, unsigned int *to, int n );
extern int uhi2vs ( unsigned int *from, void *vto, int n );
extern int vs2hl ( void *vfrom, int64_t *to, int n );
extern int hl2vs ( int64_t *from, void *vto, int n );
extern int uvs2hl ( void *vfrom, uint64_t *to, int n );
extern int uhl2vs ( uint64_t *from, void *vto, int n );
extern int vs2hf ( void *vfrom, float *to, int n );
extern int hf2vs ( float *from, void *vto, int n );
extern int uvs2hf ( void *vfrom, float *to, int n );
extern int uhf2vs ( float *from, void *vto, int n );
extern int vs2hd ( void *vfrom, double *to, int n );
extern int hd2vs ( double *from, void *vto, int n );
extern int uvs2hd ( void *vfrom, double *to, int n );
extern int uhd2vs ( double *from, void *vto, int n );
extern int vi2hi ( void *vfrom, int *to, int n );
extern int hi2vi ( int *from, void *vto, int n );
extern int uvi2hi ( void *vfrom, unsigned int *to, int n );
extern int uhi2vi ( unsigned int *from, void *vto, int n );
extern int vi2hl ( void *vfrom, int64_t *to, int n );
extern int hl2vi ( int64_t *from, void *vto, int n );
extern int uvi2hl ( void *vfrom, uint64_t *to, int n );
extern int uhl2vi ( uint64_t *from, void *vto, int n );
extern int vi2hf ( void *vfrom, float *to, int n );
extern int hf2vi ( float *from, void *vto, int n );
extern int uvi2hf ( void *vfrom, float *to, int n );
extern int uhf2vi ( float *from, void *vto, int n );
extern int vi2hd ( void *vfrom, double *to, int n );
extern int hd2vi ( double *from, void *vto, int n );
extern int uvi2hd ( void *vfrom, double *to, int n );
extern int uhd2vi ( double *from, void *vto, int n );
extern int vl2hl ( void *vfrom, int64_t *to, int n );
extern int hl2vl ( int64_t *from, void *vto, int n );
extern int uvl2hl ( void *vfrom, uint64_t *to, int n );
extern int uhl2vl ( uint64_t *from, void *vto, int n );
extern int vl2hd ( void *vfrom, double *to, int n );
extern int hd2vl ( double *from, void *vto, int n );
extern int uvl2hd ( void *vfrom, double *to, int n );
extern int uhd2vl ( double *from, void *vto, int n );
extern int vf2hi ( void *vfrom, int *to, int n );
extern int hi2vf ( int *from, void *vto, int n );
extern int uvf2hi ( void *vfrom, unsigned int *to, int n );
extern int uhi2vf ( unsigned int *from, void *vto, int n );
extern int vf2hl ( void *vfrom, int64_t *to, int n );
extern int hl2vf ( int64_t *from, void *vto, int n );
extern int uvf2hl ( void *vfrom, uint64_t *to, int n );
extern int uhl2vf ( uint64_t *from, void *vto, int n );
extern int vf2hf ( void *vfrom, float *to, int n );
extern int vd2hf ( void *vfrom, float *to, int n );
extern int hf2vf ( float *from, void *vto, int n );
extern int vf2hd ( void *vfrom, double *to, int n );
extern int hd2vf ( double *from, void *vto, int n );
extern int vd2hl ( void *vfrom, int64_t *to, int n );
extern int hl2vd ( int64_t *from, void *vto, int n );
extern int uvd2hl ( void *vfrom, uint64_t *to, int n );
extern int uhl2vd ( uint64_t *from, void *vto, int n );
extern int vd2hd ( void *vfrom, double *to, int n );
extern int hd2vd ( double *from, void *vto, int n );


/* old, deprecated routines */
extern int H2N2 ( void *dst, void *src, int n );
extern int H2N4 ( void *dst, void *src, int n );
extern int H2N8 ( void *dst, void *src, int n );
extern int N2H2 ( void *dst, void *src, int n );
extern int N2H4 ( void *dst, void *src, int n );
extern int N2H8 ( void *dst, void *src, int n );
extern int UH2N2 ( char *dst, char *src, int n );
extern int UH2N4 ( char *dst, char *src, int n );
extern int UH2N8 ( char *dst, char *src, int n );
extern int UN2H2 ( char *dst, char *src, int n );
extern int UN2H4 ( char *dst, char *src, int n );
extern int UN2H8 ( char *dst, char *src, int n );
extern int H2NS ( unsigned char *dst, short int *src, int n );
extern int H2NI ( unsigned char *dst, int *src, int n );
extern int H2NL ( unsigned char *dst, int64_t *src, int n );
extern int H2ND ( unsigned char *dst, double *src, int n );
extern int N2HS ( short int *dst, unsigned char *src, int n );
extern int N2HI ( int *dst, unsigned char *src, int n );
extern int N2HL ( int64_t *dst, unsigned char *src, int n );
extern int N2HD ( double *dst, unsigned char *src, int n );
extern int UH2NS ( unsigned char *dst, unsigned short int *src, int n );
extern int UH2NI ( unsigned char *dst, unsigned int *src, int n );
extern int UH2NL ( unsigned char *dst, uint64_t *src, int n );
extern int UN2HS ( unsigned short int *dst, unsigned char *src, int n );
extern int UN2HI ( unsigned int *dst, unsigned char *src, int n );
extern int UN2HL ( uint64_t *dst, unsigned char *src, int n );
extern double htond ( double val );
extern double ntohd ( double val );
extern void htondp ( double *valp_from, double *valp_to );
extern void ntohdp ( double *valp_from, double *valp_to );
extern float htonf ( float val );
extern float ntohf ( float val );
extern void htonfp ( float *valp_from, float *valp_to );
extern void ntohfp ( float *valp_from, float *valp_to );
extern void ntoh8p ( void *valp_from, void *valp_to );
extern void hton8p ( void *valp_from, void *valp_to );

extern void swap2 ( void *vfrom, void *vto, int n );
extern void swap4 ( void *vfrom, void *vto, int n );
extern void swap8 ( void *vfrom, void *vto, int n );
extern void N32H4 ( int *to, char *from, int n );
extern void H42N3 ( char *to, int *from, int n );
extern void NF2HD ( double *to, char *from, int n );
extern void HD2NF ( char *to, double *from, int n );
extern void HI2NC ( char *to, int *from, int n );
extern void HI2NS ( char *to, int *from, int n );
extern void NC2HI ( int *to, char *from, int n );
extern void NS2HI ( int *to, char *from, int n );
extern void HI2NF ( char *to, int *from, int n );
extern void NF2HI ( int *to, char *from, int n );

extern int md2hf ( void *vfrom, float *to, int n ) ;

#ifdef  __cplusplus
}
#endif

#endif
